
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "game.h"

void halt_and_catch_fire(BYTE f)
{
    printf("boom %u\n", f);
    exit(0);
}

void dump_well(void)
{
    BYTE x, y;
    for (y = 0; y < NUM_ROWS; y++) {
        printf("|");
        for (x = 0; x < NUM_COLUMNS; x++) {
            if (get_well(y, x)) {
                printf("##");
            } else {
                printf("..");
            }
        }
        printf("|\n");
    }
}
extern WORD goodheight_weight;
extern WORD gaps_weight;
extern WORD edges_weight;
extern WORD startpunishgap;
extern WORD bottom_well_weight;
extern WORD full_row_weight;
extern DWORD rng_value;

int main(int argc, char ** argv)
{
    int i;

    game_init(1);
    if ((argc == 3) && (strcmp(argv[1], "x") == 0)) {
#define GS 5
        const unsigned count[GS] = {10, 40, 50, 400, 1500};
        unsigned best_total[GS];
        unsigned best_max_score[GS];
        unsigned test = 0;
        unsigned par = atoi(argv[2]);

        memset(best_total, 0, sizeof(best_total));
        memset(best_max_score, 0, sizeof(best_max_score));

        srand(par + 12345);
        while(1) {
            unsigned total = 0;
            unsigned max_score = 0;
            unsigned j = 0;

            if (test != 0) {
                goodheight_weight = 4 * (rand() % 20);
                gaps_weight = rand() % 20;
                edges_weight = 10 * (rand() % 20);
                startpunishgap = rand() % 10;
                bottom_well_weight = rand() % 10;
                full_row_weight = 20 * (rand() % 10);
            }

            test++;
            printf("\n\ntest %u par %u:\n"
            "  goodheight_weight = %u\n"
            "  gaps_weight = %u\n"
            "  edges_weight = %u\n"
            "  startpunishgap = %u\n"
            "  full_row_weight = %u\n"
            "  bottom_well_weight = %u\n", test, par,
                goodheight_weight, gaps_weight, edges_weight,
                startpunishgap, full_row_weight, bottom_well_weight);
            fflush(stdout); 
            game_init(1);
            for (i = 0; i < GS; i++) {
                j = count[i];
                do {
                    game_reset();
                    while (game_step() != GAME_OVER) {}
                    if (score > max_score) max_score = score;
                    total += score;
                    j--;
                } while (j);

                printf("  G%u %u %u\n", i, max_score, total);
                fflush(stdout); 

                if ((total < best_total[i]) 
                && (max_score < best_max_score[i])) {
                    break; /* Reject */
                }

                if (max_score > best_max_score[i]) {
                    best_max_score[i] = max_score;
                }
                if (total > best_total[i]) {
                    if (i == (GS - 1)) {
                        printf("  winner by %u\n", total - best_total[i]);
                    }
                    best_total[i] = total;
                }
            }
            fflush(stdout); 
        }
    } else if ((argc == 2) && (strcmp(argv[1], "y") == 0)) {
        for (i = 1; i < 10000; i++) {
            unsigned moves = 0;
            DWORD seed;
            game_init(i);
            seed = rng_value;
            game_reset();
            while (game_step() != GAME_OVER) { moves++; }
            //dump_well();
            printf("Game %u seed %u score %u moves %u\n", i, seed, score, moves);
        }
    } else {
        unsigned moves = 1;
        game_reset();
        while (game_step() != GAME_OVER) { 
            printf("\n\n\nMove %u score %u\n", moves, score);
            moves++; 
            dump_well();
        }
    }
    return 0;
}

